package be.iminds.ilabt.jfed.restapi.dao;

import be.iminds.ilabt.jfed.fedmon.util.Clock;

import java.sql.Timestamp;
import java.util.Date;

/**
 * TestClock: helper for TestTasks, TestResults and TestTestInstances time fields
 */
public class TestClock {
    private long base;

    public TestClock() {
        //force DefaultFixedTestTimeProvider to make sure correct Clock is aways used
        base = new Clock.DefaultTestTimeProvider().currentTimeMillis() - 10 * 60 * 1000l; // = 2015-11-30T12:00:00Z
    }

    private static TestClock testClock;
    public static TestClock get() {
        if (testClock == null) testClock = new TestClock();
        return testClock;
    }

    public Date getBaseDate() {
        return new Date(base);
    }
    public Timestamp getBase() {
        return new Timestamp(base);
    }

    public Timestamp getOffsetMillis(long offsetMs) {
        return new Timestamp(base + offsetMs);
    }
    public Timestamp getOffsetSeconds(long offsetS) {
        return new Timestamp(base + (offsetS * 1000l));
    }
    public Timestamp getOffsetMinutes(long offsetMin) {
        return new Timestamp(base + (offsetMin * 60 * 1000l));
    }
}
